#!/usr/bin/python
import sys
from os.path import *
from pyflann import *
import os
from copy import copy
from numpy import *
from numpy.random import *
import unittest, time

class Test_PyFLANN_clustering(unittest.TestCase):

    def setUp(self):
        self.nn = FLANN(iterations=11)

    ################################################################################


    def test10d_large(self):
        self.__nd_random_clustering_test(10,2,10)


    def __nd_random_clustering_test(self, dim, N, dup=1):
        """
        Make a set of random points, then pass the same ones to the
        query points.  Each point should be closest to itself.
        """
#        seed(0)
        x = rand(N, dim)
        xc = concatenate(tuple([x for i in xrange(dup)]))

        if dup > 1: xc += randn(xc.shape[0], xc.shape[1])*0.000001/dim

        centroids = self.nn.kmeans(xc[permutation(len(xc))], N, centers_init = "random", random_seed=2)
        if dim==10:
#            print x
            print centroids
        #print N
        #print centroids.shape
        mindists = array([[ sum((d1-d2)**2) for d1 in x] for d2 in centroids]).min(0)
        print mindists
        for m in mindists: self.assertAlmostEqual(m, 0.0, 1)
        print x

        
if __name__ == '__main__':
    unittest.main()
